###
# Modern Albufeira Prolog Interpreter
#
# Warranty & Liability
# To the extent permitted by applicable law and unless explicitly
# otherwise agreed upon, XLOG Technologies AG makes no warranties
# regarding the provided information. XLOG Technologies AG assumes
# no liability that any problems might be solved with the information
# provided by XLOG Technologies AG.
#
# Rights & License
# All industrial property rights regarding the information - copyright
# and patent rights in particular - are the sole property of XLOG
# Technologies AG. If the company was not the originator of some
# excerpts, XLOG Technologies AG has at least obtained the right to
# reproduce, change and translate the information.
#
# Reproduction is restricted to the whole unaltered document. Reproduction
# of the information is only allowed for non-commercial uses. Selling,
# giving away or letting of the execution of the library is prohibited.
# The library can be distributed as part of your applications and libraries
# for execution provided this comment remains unchanged.
#
# Restrictions
# Only to be distributed with programs that add significant and primary
# functionality to the library. Not to be distributed with additional
# software intended to replace any components of the library.
#
# Trademarks
# Jekejeke is a registered trademark of XLOG Technologies AG.
##

from collections import OrderedDict
from nova.core import (is_compound, is_variable, set_to_list,
       make_check, walk_vars, is_structure, object_hash_code,
       exec_build, int32, assoc_get, assoc_set, stack_push,
       stack_peek, stack_pop, Item, deref, add, VAR_MASK_SEEN,
       exec_unify, check_integer, make_error, Compound,
       make_arithmetic, exec_eval)
import math

################################################################
# term_singletons/2                                            #
################################################################

###
# term_singletons(T, L):
# The built-in succeeds in L with the singleton variables of T.
##
def test_term_singletons(args):
    alpha = exec_build(args[0])
    alpha = walk_singletons(alpha)
    for key, val in list(alpha.items()):
        if val:
            del alpha[key]
    alpha = set_to_list(alpha.keys())
    return exec_unify(args[1], alpha)


###
# Walk a Prolog term completely.
#
# @param first The Prolog term.
# @return The singletons.
##
def walk_singletons(first):
    stack = None
    vmap = None
    while True:
        first = deref(first)
        if is_variable(first):
            first = dict([[first, False]])
        elif is_compound(first):
            peek = assoc_get(vmap, first)
            if peek is NotImplemented:
                vmap = assoc_set(vmap, first, EMPTY_MAP)
                item = Item(first, EMPTY_MAP, 0)
                stack = stack_push(stack, item)
                first = first.args[0]
                continue
            else:
                first = peek
        else:
            first = EMPTY_MAP
        item = stack_peek(stack)
        while (item is not None and
                item.idx == len(item.first.args) - 1):
            first = union_map(item.second, first)
            vmap = assoc_set(vmap, item.first, first)
            stack_pop(stack)
            item = stack_peek(stack)
        if item is None:
            return first
        else:
            item.second = union_map(item.second, first)
            item.idx += 1
            first = item.first.args[item.idx]


EMPTY_MAP = OrderedDict()


def union_map(first, second):
    if len(first) == 0:
        return second
    if len(second) == 0:
        return first
    first = OrderedDict(first)
    for key, val in second.items():
        value = first.get(key, NotImplemented)
        if value is not NotImplemented:
            value = True
        else:
            value = val
        first[key] = value
    return first


#######################################################################
# ground/1 and nonground/2                                            #
#######################################################################

###
# ground(T): [TC2 8.3.10]
# The built-in succceeds if T is ground.
##
def test_ground(args):
    alpha = exec_build(args[0])
    res = walk_vars(alpha, lambda node: True, VAR_MASK_SEEN)
    walk_vars(alpha, lambda node: True, 0)
    return not res


###
# nonground(T, V):
# The built-in succeeds if T is non-ground and V is the first variable.
##
def test_nonground(args):
    alpha = exec_build(args[0])
    hit = NotImplemented

    def nonground2(node):
        nonlocal hit
        hit = node
        return True

    res = walk_vars(alpha, nonground2, VAR_MASK_SEEN)
    walk_vars(alpha, lambda node: True, 0)
    return res and exec_unify(args[1], hit)


#######################################################################
# term_hash/2                                                         #
#######################################################################

###
# term_hash(X, H):
# The predicate succeeds in H with the term hash of the term X.
##
def test_term_hash(args):
    alpha = exec_build(args[0])
    res = walk_hash(alpha)
    return exec_unify(args[1], res)


###
# Walk a Prolog term completely.
#
# @param first The Prolog term.
# @return The hash.
##
def walk_hash(first):
    stack = None
    vmap = None
    while True:
        first = deref(first)
        if is_structure(first):
            peek = assoc_get(vmap, first)
            if peek is NotImplemented:
                vmap = assoc_set(vmap, first, 0)
                peek = object_hash_code(first.functor)
                item = Item(first, peek, 0)
                stack = stack_push(stack, item)
                first = first.args[0]
                continue
            else:
                first = peek
        else:
            first = object_hash_code(first)
        item = stack_peek(stack)
        while (item is not None and
               item.idx == len(item.first.args) - 1):
            first = int32(item.second * 31 + first)
            vmap = assoc_set(vmap, item.first, first)
            stack_pop(stack)
            item = stack_peek(stack)
        if item is None:
            return first
        else:
            item.second = int32(item.second * 31 + first)
            item.idx += 1
            first = item.first.args[item.idx]


#######################################################################
# divmod/4 and gcd/3                                                  #
#######################################################################

###
# divmod(X, Y, Z, T):
# If X and Y are both integers then the predicate succeeds in
# Z with the division of X by Y, and in T with the modulo of X by Y.
##
def test_divmod(args):
    alpha = exec_build(args[0])
    check_integer(alpha)
    beta = exec_build(args[1])
    check_integer(beta)
    if beta == 0:
        raise make_error(Compound("evaluation_error", ["zero_divisor"]))
    (divres, modres) = divmod(alpha, beta)
    if not exec_unify(args[2], divres):
        return False
    return exec_unify(args[3], modres)


###
# gcd(X, Y, Z):
# If X and Y are integers then the predicate succeeds in Z
# with the greatest common divisor of X and Y.
##
def arit_gcd(args):
   alpha = exec_eval(args[0])
   check_integer(alpha)
   beta = exec_eval(args[1])
   check_integer(beta)
   return math.gcd(alpha, beta)


#######################################################################
# Fast Lib Init                                                       #
#######################################################################

def main():
    add("term_singletons", 2, make_check(test_term_singletons))
    add("ground", 1, make_check(test_ground))
    add("nonground", 2, make_check(test_nonground))
    add("term_hash", 2, make_check(test_term_hash))
    add("divmod", 4, make_check(test_divmod))
    add("gcd", 3, make_arithmetic(arit_gcd))
